/***************************************************************
** Name:        htmlpage.h
** Author:      Leo Liberti
** Source:      GNU C++
** Purpose:     www exploring topologizer - HTML page handler (header)
** History:     060820 work started
****************************************************************/

#ifndef _WETHTMLPAGEH
#define _WETHTMLPAGEH

#include "fileparser.h"
#include<string>
#include<vector>

class HTMLPageException {
 public:
  HTMLPageException();
  ~HTMLPageException();
};

class HTMLPage : public FileParser {
 public:
  HTMLPage(std::string theFileName, std::string theURL) 
    throw(HTMLPageException);
  ~HTMLPage();  
  
  int getNumberOfLinks(void) const;
  std::string getLink(int i) const throw(HTMLPageException);

 private:
  // check whether a given link is an HTTP link
  bool isHTTP(const std::string& theLink) const;

  // construct an absolute URL from a relative one
  std::string makeAbsoluteURL(const std::string& theLink) const;

  std::string htmlFileName;
  std::string URL;
  std::string URLPrefix;
  std::vector<std::string> link;
};

#endif
