/*******************************************************
** Name:        timestamp.h
** Author:      Leo Liberti
** Source:      GNU C++
** Purpose:     www exploring topologizer: TimeStamp class header
** History:     060820 work started
*******************************************************/

#ifndef _WETTIMESTAMPH
#define _WETTIMESTAMPH

#include<iostream>
#include<sys/time.h>

class TimeStampException {
 public:
  TimeStampException();
  ~TimeStampException();
};

class TimeStamp {

 public:

  TimeStamp() : timestamp(0) { } ;
  ~TimeStamp() { }

  long get(void) const;
  void set(long theTimeStamp);

  // read the system clock and update the timestamp
  void update(void) throw (TimeStampException);

 private:

  long timestamp;
  
};

// print the timestamp in humanly readable form
std::ostream& operator<<(std::ostream& s, TimeStamp& t) 
     throw (TimeStampException);

#endif
